// Table Creation Example


#include <iostream.h>

#include <string.h>

#include <dew.h>


int main()
{
    // Start the engine.

    TDEWEngine engine;

    // Open a database.

    TDEWDatabase database;

    // Try to create the table "DEW_TEST.DB".

    try {

        // Declare table description variables.

        CRTblDesc descriptor;
        FLDDesc fields[3];
        IDXDesc index;

        // Zero table description variables.

        memset(&descriptor, 0, sizeof(CRTblDesc));
        memset(fields, 0, 3 * sizeof(FLDDesc));
        memset(&index, 0, sizeof(IDXDesc));

        // Make the table have three fields and one index.

        strcpy(descriptor.szTblName, "DEW_TEST.DB");
        descriptor.iFldCount = 3;
        descriptor.pfldDesc = fields;
        descriptor.iIdxCount = 1;
        descriptor.pidxDesc = &index;

        // Make first field ten characters long called "Name".

        fields[0].iFldNum = 1;
        strcpy(fields[0].szName, "Name");
        fields[0].iFldType = fldZSTRING;
        fields[0].iUnits1 = 10;

        // Make second field a date called "Date".

        fields[1].iFldNum = 2;
        strcpy(fields[1].szName, "Date");
        fields[1].iFldType = fldDATE;

        // Make third field a number called "Amount".

        fields[2].iFldNum = 3;
        strcpy(fields[2].szName, "Amount");
        fields[2].iFldType = fldFLOAT;

        // Make "Name" + "Date" the primary key.

        index.bPrimary = TRUE;
        index.iFldsInKey = 2;
        index.aiKeyFld[0] = 1;
        index.aiKeyFld[1] = 2;

        // Create the table.

        database.CreateTable(descriptor);

        cout << "Table \"DEW_TEST.DB\" creation succeeded." << endl;

    } catch(const TDEWException& exception) {

        // Report an error creating the table.

        cerr << "Table \"DEW_TEST.DB\" creation failed: " << exception << endl;

    }

    return 0;
}