// Record Insertion Example


#include <iostream.h>

#include <string.h>

#include <dew.h>


int main()
{
    // Start the engine.

    TDEWEngine engine;

    // Open a database.

    TDEWDatabase database;

    // Try to put some data in the table "DEW_TEST.DB".

    try {

        // Create a cursor for the table and find its record buffer.

        TDEWCursor cursor(database, "DEW_TEST.DB");
        TDEWRecord& record = cursor.Record();

        // Append the data.

        cursor.InitRecord();
        record.PutField("Name", "Arnold");
        record.PutField("Date", TDate());
        record.PutField("Amount", 0);
        cursor.AppendRecord();

        cursor.InitRecord();
        record.PutField(1, "Bruce");
        record.PutField(2, TDate(31, 10, 1994));
        record.PutField(3, 5.00);
        cursor.AppendRecord();

        cursor.InitRecord();
        record.PutField(1, "Charles");
        record.PutField(2, TDate(31, 10, 1994));
        record.PutBlank(3);
        cursor.AppendRecord();

        cursor.InitRecord();
        record.PutField(1, "Charles");
        record.PutField(2, TDate(1, 11, 1994));
        record.PutField(3, -2.50);
        cursor.AppendRecord();

        cout << "Records successfully added." << endl;

    } catch(const TDEWException& exception) {

        // Report an error appending the data.

        cerr << "Records could not be added: " << exception << endl;

    }

    return 0;
}