// Key Violation Example


#include <iostream.h>

#include <string.h>

#include <dew.h>


int main()
{
    // Start the engine.

    TDEWEngine engine;

    // Open a database.

    TDEWDatabase database;

    // Try to put some data in the table "DEW_TEST.DB" that violates its primary key.

    try {

        // Create a cursor for the table and find its record buffer.

        TDEWCursor cursor(database, "DEW_TEST.DB");
        TDEWRecord& record = cursor.Record();

        // Append some data that has the same key as data previously added.

        cursor.InitRecord();
        record.PutField("Name", "Arnold");
        record.PutField("Date", TDate());
        record.PutField("Amount", 10);
        try {
            cursor.AppendRecord();
            cerr << "Key violation not detected." << endl;
        } catch (const TDEWIntegrityException& exception) {
            if (exception.Result() == DBIERR_KEYVIOL)
                cout << "Key violation successfully detected." << endl;
            else
                throw;
        }

    } catch(const TDEWException& exception) {

        // Report a failure to catch the key violation.

        cerr << "Key violation not detected." << endl;

    }

    return 0;
}