// Record Reading Example


#include <iostream.h>

#include <string.h>

#include <dew.h>


int main()
{
    // Start the engine.

    TDEWEngine engine;

    // Open a database.

    TDEWDatabase database;

    // Try to extract the data from the table "DEW_TEST.DB".

    try {

        // Create a cursor for the table and find its record buffer.

        TDEWCursor cursor(database, "DEW_TEST.DB");
        TDEWRecord& record = cursor.Record();

        // Print the attributes (field) names.

        cout << "Reading (Name, Date, Amount) . . . " << endl;

        // Print all of the tuples (records).

        for (cursor.SetToBegin(); cursor.Advance(); ) {
            string name;
            TDate date;
            float amount;
            record.GetField("Name", name);
            record.GetField("Date", date);
            record.GetField("Amount", amount);
            date.SetPrintOption(TDate::Numbers);
            cout << "\t(\"" << name << "\", " << date << ", " << amount << ")" << endl;
        }

        cout << "Data successfully read." << endl;

    } catch(const TDEWException& exception) {

        // Report an error reading the data.

        cerr << "Data could not be read: " << exception << endl;

    }

    return 0;
}