// Key Search Example


#include <iostream.h>

#include <string.h>

#include <dew.h>


int main()
{
    // Start the engine.

    TDEWEngine engine;

    // Open a database.

    TDEWDatabase database;

   // Try to search for a key value in "DEW_TEST.DB".

    try {

        // Create a cursor for the table and find its record buffer.

        TDEWCursor cursor(database, "DEW_TEST.DB");
        TDEWRecord& record = cursor.Record();

        // Create a record buffer for the key.

        TDEWRecord key(cursor);

        // Search for the key.

        key.PutField("Name", "Bruce");
        cout << "Searching for (\"Bruce\", *, *) . . ." << endl;
        cursor.GetRecordForKey(key, 1);
        string name;
        TDate date;
        float amount;
        record.GetField("Name", name);
        record.GetField("Date", date);
        record.GetField("Amount", amount);
        date.SetPrintOption(TDate::Numbers);
        cout << "\t(\"" << name << "\", " << date << ", " << amount << ")" << endl;

        cout << "Search successfully completed." << endl;

    } catch(const TDEWException& exception) {

        // Report a failure of the search.

        cerr << endl << "Key could not be found: " << exception << endl;

    }

    return 0;
}