//
//  Database Engine Wrapper
//  Version 1.0
//  EXCEPTN.H
//  Copyright  1994
//  B. W. Bush
//  All rights reserved
//


#ifndef BWB_DEW_EXCEPTION
#define BWB_DEW_EXCEPTION


// DbiException class.

class TDEWException
{
  public:

    TDEWException(const DBIResult = DBIERR_NONE);

    INT16 Category() const;
    INT16 Code() const;
    string Context(const INT16) const;
    string Entry(const UINT16, UINT32&) const;
    void GetInfo(DBIErrInfo&, const BOOL = TRUE) const;
    string Message() const;
    DBIResult Result() const;

    static void CheckResult(const DBIResult);

  private:

    const DBIResult fResult;
};

ostream& operator<<(ostream&, const TDEWException&);


// Exception subclasses.

class TDEWSystemException : public TDEWException {public: TDEWSystemException(const DBIResult r) : TDEWException(r) {}};

class TDEWNotFoundException : public TDEWException {public: TDEWNotFoundException(const DBIResult r) : TDEWException(r) {}};

class TDEWDataCorruptException : public TDEWException {public: TDEWDataCorruptException(const DBIResult r) : TDEWException(r) {}};

class TDEWIoException : public TDEWException {public: TDEWIoException(const DBIResult r) : TDEWException(r) {}};

class TDEWLimitException : public TDEWException {public: TDEWLimitException(const DBIResult r) : TDEWException(r) {}};

class TDEWIntegrityException : public TDEWException {public: TDEWIntegrityException(const DBIResult r) : TDEWException(r) {}};

class TDEWInvalidReqException : public TDEWException {public: TDEWInvalidReqException(const DBIResult r) : TDEWException(r) {}};

class TDEWLockConflictException : public TDEWException {public: TDEWLockConflictException(const DBIResult r) : TDEWException(r) {}};

class TDEWSecurityException : public TDEWException {public: TDEWSecurityException(const DBIResult r) : TDEWException(r) {}};

class TDEWInvalidContextException : public TDEWException {public: TDEWInvalidContextException(const DBIResult r) : TDEWException(r) {}};

class TDEWOsException : public TDEWException {public: TDEWOsException(const DBIResult r) : TDEWException(r) {}};

class TDEWNetworkException : public TDEWException {public: TDEWNetworkException(const DBIResult r) : TDEWException(r) {}};

class TDEWOptParamException : public TDEWException {public: TDEWOptParamException(const DBIResult r) : TDEWException(r) {}};

class TDEWQueryException : public TDEWException {public: TDEWQueryException(const DBIResult r) : TDEWException(r) {}};

class TDEWVersionException : public TDEWException {public: TDEWVersionException(const DBIResult r) : TDEWException(r) {}};

class TDEWCapabilityException : public TDEWException {public: TDEWCapabilityException(const DBIResult r) : TDEWException(r) {}};

class TDEWConfigException : public TDEWException {public: TDEWConfigException(const DBIResult r) : TDEWException(r) {}};

class TDEWWarningException : public TDEWException {public: TDEWWarningException(const DBIResult r) : TDEWException(r) {}};

class TDEWOtherException : public TDEWException {public: TDEWOtherException(const DBIResult r) : TDEWException(r) {}};

class TDEWCompatibilityException : public TDEWException {public: TDEWCompatibilityException(const DBIResult r) : TDEWException(r) {}};

class TDEWDriverException : public TDEWException {public: TDEWDriverException(const DBIResult r) : TDEWException(r) {}};

class TDEWInternalException : public TDEWException {public: TDEWInternalException(const DBIResult r) : TDEWException(r) {}};


#endif // BWB_DEW_EXCEPTION
