//
//  Database Engine Wrapper
//  Version 1.0
//  RECORD.H
//  Copyright  1994
//  B. W. Bush
//  All rights reserved
//


#ifndef BWB_DEW_RECORD
#define BWB_DEW_RECORD


// TDEWRecord class.

class TDEWRecord
{
    friend class TDEWBlob;
    friend class TDEWCursor;

  public:

    TDEWRecord(TDEWCursor&);
    ~TDEWRecord();

    UINT32 BlobSize(const string&) const;
    UINT32 BlobSize(const UINT16) const;
    TDEWCursor& Cursor();
    const TDEWCursor& Cursor() const;
    string FieldName(const UINT16) const;
    UINT16 FieldNumber(const string&) const;
    BOOL GetField(const string&, string&) const;
    BOOL GetField(const UINT16, string&) const;
    BOOL GetField(const string&, INT16&) const;
    BOOL GetField(const UINT16, INT16&) const;
    BOOL GetField(const string&, INT32&) const;
    BOOL GetField(const UINT16, INT32&) const;
    BOOL GetField(const string&, UINT16&) const;
    BOOL GetField(const UINT16, UINT16&) const;
    BOOL GetField(const string&, UINT32&) const;
    BOOL GetField(const UINT16, UINT32&) const;
    BOOL GetField(const string&, float&) const;
    BOOL GetField(const UINT16, float&) const;
    BOOL GetField(const string&, double&) const;
    BOOL GetField(const UINT16, double&) const;
    BOOL GetField(const string&, long double&) const;
    BOOL GetField(const UINT16, long double&) const;
    BOOL GetField(const string&, TDate&) const;
    BOOL GetField(const UINT16, TDate&) const;
    BOOL GetField(const string&, TTime&) const;
    BOOL GetField(const UINT16, TTime&) const;
    BOOL GetField(const string&, TDate&, TTime&) const;
    BOOL GetField(const UINT16, TDate&, TTime&) const;
    BOOL IsBlank(const string&) const;
    BOOL IsBlank(const UINT16) const;
    void PutBlank(const string&);
    void PutBlank(const UINT16);
    void PutField(const string&, const string&);
    void PutField(const UINT16, const string&);
    void PutField(const string&, const INT16);
    void PutField(const UINT16, const INT16);
    void PutField(const string&, const INT32);
    void PutField(const UINT16, const INT32);
    void PutField(const string&, const UINT16);
    void PutField(const UINT16, const UINT16);
    void PutField(const string&, const UINT32);
    void PutField(const UINT16, const UINT32);
    void PutField(const string&, const float);
    void PutField(const UINT16, const float);
    void PutField(const string&, const double);
    void PutField(const UINT16, const double);
    void PutField(const string&, const long double);
    void PutField(const UINT16, const long double);
    void PutField(const string&, const TDate&);
    void PutField(const UINT16, const TDate&);
    void PutField(const string&, const TTime&);
    void PutField(const UINT16, const TTime&);
    void PutField(const string&, const TDate&, const TTime&);
    void PutField(const UINT16, const TDate&, const TTime&);
    BOOL VerifyField(const string&) const;
    BOOL VerifyField(const UINT16) const;

  private:

    TDEWRecord(const TDEWRecord&) : fCursor(*((TDEWCursor*) NULL)), fBuffer(0) {}

    TDEWRecord& operator=(const TDEWRecord&) {fCursor = *((TDEWCursor*) NULL); fBuffer = 0; return *this;}

    void CheckFieldNumber(const UINT16 iField) const {if (iField > fCursor.fCursorProps.iFields) TDEWException::CheckResult(DBIERR_OUTOFRANGE);}

    pBYTE fBuffer;
    TDEWCursor& fCursor;
};


#endif // BWB_DEW_RECORD
