//
//  Database Engine Wrapper
//  Version 1.0
//  STATEMNT.H
//  Copyright  1994
//  B. W. Bush
//  All rights reserved
//


#ifndef BWB_DEW_STATEMENT
#define BWB_DEW_STATEMENT


// TDEWStatement class.

class TDEWStatement
  : public MDEWObject
{
  public:

    TDEWStatement();
    TDEWStatement(TDEWDatabase&);
    TDEWStatement(TDEWDatabase&, const pcCHAR, const DBIQryLang = qrylangSQL);
    ~TDEWStatement();

    void Close();
    hDBIDb DatabaseHandle() const {return fHDatabase;}
    hDBIStmt Handle() const {return fHStatement;}
    void Open(TDEWDatabase&, const pcCHAR, const DBIQryLang = qrylangSQL);
    void Open(const pcCHAR, const DBIQryLang = qrylangSQL);
    TDEWCursor Query() const;
    void SetParams(const UINT16, const pcFLDDesc, const pcBYTE);

  private:

    TDEWStatement(const TDEWStatement&) : fHDatabase(NULL), fHStatement(NULL) {}

    TDEWStatement& operator=(const TDEWStatement&) {if (IsOpen()) Close(); return *this;}

    hDBIDb fHDatabase;
    hDBIStmt fHStatement;
};


#endif // BWB_DEW_STATEMENT
