//
//  Database Engine Wrapper
//  Version 1.0
//  TRANSACT.H
//  Copyright  1994
//  B. W. Bush
//  All rights reserved
//


#ifndef BWB_DEW_TRANSACTION
#define BWB_DEW_TRANSACTION


// TDEWTransaction class.

class TDEWTransaction
  : public MDEWObject
{
  public:

    TDEWTransaction();
    TDEWTransaction(TDEWDatabase&);
    TDEWTransaction(TDEWDatabase&, const eXILType);
    ~TDEWTransaction();

    void Close(const eXEnd = xendCOMMITKEEP);
    hDBIDb DatabaseHandle() const {return fHDatabase;}
    void GetTranInfo(XInfo&) const;
    hDBIXact Handle() const {return fHTransaction;}
    void Open(TDEWDatabase&, const eXILType);
    void Open(const eXILType);

  private:

    TDEWTransaction(const TDEWTransaction&) : fHDatabase(NULL), fHTransaction(NULL) {}

    TDEWTransaction& operator=(const TDEWTransaction&) {if (IsOpen()) Close(); return *this;}

    hDBIDb fHDatabase;
    hDBIXact fHTransaction;
};


#endif // BWB_DEW_TRANSACTION