//
//  Database Engine Wrapper
//  Version 1.0
//  SESSION.CPP
//  Copyright  1994
//  B. W. Bush
//  All rights reserved
//


// Definitions.

#include <dew.h>        // database engine wrapper


// Constructor.

TDEWSession::TDEWSession(const pcCHAR pszName, const pcCHAR pNetDir)
  : fHSession(NULL)
{
    Open(pszName, pNetDir);
}


TDEWSession::TDEWSession(TDEWEngine&)
  : fHSession(NULL)
{
    TDEWException::CheckResult(DbiGetCurrSession(&fHSession));
}


// Destructor.

TDEWSession::~TDEWSession()
{
    if (IsOpen())
        Close();
}


// Close session.

void TDEWSession::Close()
{
    TDEWException::CheckResult(DbiCloseSession(fHSession));
    fHSession = NULL;
}


// Open session.

void TDEWSession::Open(const pcCHAR pszName, const pcCHAR pNetDir)
{
    if (IsOpen())
        Close();

    TDEWException::CheckResult(DbiStartSession((pCHAR) pszName, &fHSession, (pCHAR) pNetDir));
}

void TDEWSession::Open(TDEWEngine&)
{
    if (IsOpen())
        Close();

    TDEWException::CheckResult(DbiGetCurrSession(&fHSession));
}
